stages:
  - build
  - package
  - deploy

variables:
   GIT_SUBMODULE_STRATEGY: recursive


#-----------------------------------------------------------
#                      TEMPLATES
#-----------------------------------------------------------

.build_win_template: &win_build_definition
  stage: build
  image: registry.gitlab.com/immersaview/public/ci-docker-images/ci-cpp-build-deps:1.1.1-windows2019
  tags:
    - imv-windows-docker
  artifacts:
    expire_in: 4 hours
    paths:
      - "$OS/$TOOL/$ARCH/source/lib/$CONFIG/*.lib"
      - "$OS/$TOOL/$ARCH/source/config/ceres/internal/*.h"
  script:
    - bash ./build.sh $OS $ARCH $CONFIG $TOOL

#-----------------------------------------------------------
#                      WINDOWS BUILDS
#-----------------------------------------------------------

build_win_vs2019_x64_rel:
  <<: *win_build_definition

  variables:
    OS: "windows"
    ARCH: "x64"
    CONFIG: "Release"
    TOOL: "vc142"

build_win_vs2019_x64_dbg:
  <<: *win_build_definition

  variables:
    OS: "windows"
    ARCH: "x64"
    CONFIG: "Debug"
    TOOL: "vc142"

build_win_vs2019_x86_rel:
  <<: *win_build_definition

  variables:
    OS: "windows"
    ARCH: "x86"
    CONFIG: "Release"
    TOOL: "vc142"

build_win_vs2019_x86_dbg:
  <<: *win_build_definition

  variables:
    OS: "windows"
    ARCH: "x86"
    CONFIG: "Debug"
    TOOL: "vc142"


#-----------------------------------------------------------
#                      PACKAGE
#-----------------------------------------------------------

package:
  stage: package
  image: registry.gitlab.com/immersaview/public/ci-docker-images/ci-cpp-build-deps:1.5.0-ubuntu18_04
  script:
    - pushd NuGet
    - nuget pack
    - bash ./check_package_exists.sh
    - popd
  artifacts:
    expire_in: 4 hours
    paths:
      - "NuGet/*.nupkg"

#-----------------------------------------------------------
#                      DEPOLY
#-----------------------------------------------------------

deploy:
  stage: deploy
  image: registry.gitlab.com/immersaview/public/ci-docker-images/ci-cpp-build-deps:1.5.0-ubuntu18_04
  script:
    - pushd NuGet
    - nuget source Add -Name gitlab -Source "$CI_SERVER_URL/api/v4/projects/$CI_PROJECT_ID/packages/nuget/index.json" -UserName gitlab-ci-token -Password $CI_JOB_TOKEN
    - nuget push *.nupkg  -Source gitlab
    - popd
  only:
    - master
  needs:
    - job: package
      artifacts: true

